<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2020 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

class plgEventbookingSMSTwilio extends JPlugin
{
	public function onEBSendingSMSReminder($rows)
	{
		require_once JPATH_ROOT . '/plugins/eventbookingsms/twilio/twilio/vendor/autoload.php';

		$accountSid      = $this->params->get('account_sid');
		$authToken       = $this->params->get('auth_token');
		$fromPhoneNumber = $this->params->get('from_phone_number');

		if (!$accountSid || !$authToken || !$fromPhoneNumber)
		{
			return;
		}

		$client = new \Twilio\Rest\Client($accountSid, $authToken);

		foreach ($rows as $row)
		{
			try
			{
				$client->messages->create(
					$row->phone,
					[
						'from' => $fromPhoneNumber,
						'body' => $row->sms_message,
					]
				);
			}
			catch (Exception $e)
			{
				EventbookingHelper::logData(__DIR__ . '/twilio_error.txt', ['id' => $row->id, 'phone' => $row->phone, 'error' => $e->getMessage()]);
			}
		}

		// Return true to tell the system that SMS were successfully sent so that it could update sms sending status for registrants
		return true;
	}
}